Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2481 by niro, Wed Jan 8 10:27:55 2014 UTC revision 2887 by niro, Fri Jul 31 10:48:17 2015 UTC
# Line 9  Line 9 
9    
10  # setup locales  # setup locales
11  TEXTDOMAIN=installer  TEXTDOMAIN=installer
 LC_MESSAGES=C  
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
# Line 41  do Line 40  do
40   fi   fi
41  done  done
42    
 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  
 # -> now in images.conf  
 CDIMAGENAME=""  
 TOTALLINES=""  
 CURRENTLINE=0  
 if [ -e /mnt/cdrom/system/images.conf ]  
 then  
  source /mnt/cdrom/system/images.conf  
  # check if all required variables are set  
  [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"  
  [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"  
 else  
  die "/mnt/cdrom/system/images.conf not found"  
 fi  
   
43  ### System/Config Version  ### System/Config Version
44  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
45  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
46    
47  # some sane defaults  # some sane defaults
48  CDROOT="${DEFAULT_CDROOT}"  LIVEROOT="${DEFAULT_LIVEROOT}"
49    IMAGEROOT="${DEFAULT_IMAGEROOT}"
50  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
51  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
52  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
# Line 72  SPECIALDEVICE="" Line 57  SPECIALDEVICE=""
57  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
58  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
59    
60  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
61  #  DIALOG BOXEN #  # -> now in images.conf
62  #################################################  CDIMAGENAME=""
63    TOTALLINES=""
64    CURRENTLINE=0
65    if [ -e ${IMAGEROOT}/images.conf ]
66    then
67     source ${IMAGEROOT}/images.conf
68     # check if all required variables are set
69     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
70     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
71    else
72     die "${IMAGEROOT}/images.conf not found"
73    fi
74    
75    ### helper scripts ###
76    
77  trap_exit()  trap_exit()
78  {  {
# Line 88  trap_exit() Line 86  trap_exit()
86   exit 1   exit 1
87  }  }
88    
89  dialog_die()  install_meter()
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
90  {  {
91   local retval   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
92     do
93   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"   CURRENTLINE=$(grep -c . /tmp/install.log)
94   retval=$?   PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
95   if [[ ${retval} -eq 1 ]]   echo ${PERCENT}
96   then   sleep 1
97   clear   done
98   echo $"The process was aborted."   rm -f /tmp/install.log
99   exit 1   return 0
  fi  
100  }  }
101    
102  task_setup_system_menu()  mount_rootfs()
103  {  {
  local mode  
104   local retval   local retval
105    
106   mode="$(dialog_setup_system_menu)"   if [[ -n ${SWAPHDD} ]]
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
107   then   then
108   case "${mode}" in   swapon ${SWAPHDD} || dialog_die $"Could not enable swap space '${SWAPHDD}'"
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") task_setup_system_menu;;  
  esac  
  fi  
 }  
   
 task_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  message+="\n"  
  message+=$"Optical disk drives:\n"  
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
109   fi   fi
110    
111   # other devices   if [[ -n ${ROOTHDD} ]]
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
112   then   then
113   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"   if is_mounted --location "${INSTALLROOT}"
114     then
115     echo $"${INSTALLROOT} already mounted" >&2
116     else
117     mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
118     fi
119   fi   fi
120    
121   messagebox -y 12 -h $"Detected hardware:" "${message}"   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
 }  
122    
123  task_setup_hdd_partitions_manual()   if [[ -n ${BOOTHDD} ]]
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
124   then   then
125   dialog_no_harddrive_found   if is_mounted --location "${INSTALLROOT}"/boot
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
126   then   then
127   dialog_setup_hdd_info   echo $"${INSTALLROOT}/boot already mounted" >&2
128   setup_hdd_partitions_manual   else
129     mount "${BOOTHDD}" "${INSTALLROOT}"/boot || dialog_die $"Could not mount bootfs - drive '${BOOTHDD}' -> '${INSTALLROOT}/boot'"
130   fi   fi
131   fi   fi
132  }  }
133    
134  task_setup_hdd_partitions_auto()  umount_rootfs()
135  {  {
136   local i   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
137   local retval   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
138    
139   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${SWAPHDD} ]]
140   then   then
141   dialog_no_harddrive_found   swapoff ${SWAPHDD} || die
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
142   fi   fi
143  }  }
144    
145  install_meter()  install_do_reboot()
 {  
  while [[ ${CURRENTLINE} != ${TOTALLINES} ]]  
  do  
  CURRENTLINE=$(grep -c . /tmp/install.log)  
  PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))  
  echo ${PERCENT}  
  sleep 1  
  done  
  rm -f /tmp/install.log  
  return 0  
 }  
   
 task_main()  
146  {  {
147   local method=0   reboot
  local retval  
   
  while [[ ${method} -le 2 ]]  
  do  
  method=$(dialog_main)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && exit 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case ${method} in  
  "1") task_setup_system_menu ;;  
  "2") task_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
148  }  }
149    
 #################################################  
 # Install Komandos #  
 #################################################  
150  run_hardware_detection()  run_hardware_detection()
151  {  {
152   local hwinfo   local hwinfo
153    
154   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
155    
156   ## check for special devices/clients:   # check for special devices/clients:
157   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
158   #local removable=0   local removable=0
159   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
160   #then   then
161   #for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
162   #do   #do
163   #if [[ $(< ${i}) = 1 ]]   # if [[ $(< ${i}) = 1 ]]
164   #then   # then
165   #removable=1   # removable=1
166   #fi   # fi
167   #done   #done
168   ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'   # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
169    
170   ## only add this for grub legacy, grub2 detect these settings on its own   # only add this for grub legacy, grub2 detect these settings on its own
171   #export GRUBLEGACYOPTS="rootdelay=8"   export GRUBLEGACYOPTS="rootdelay=8"
172   ## there are to zotac types in the wild, nvidia based gfx and intel   # there are to zotac types in the wild, nvidia based gfx and intel
173   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
174   #then   then
175   #export SPECIALDEVICE="zotac_nvidia"   export SPECIALDEVICE="zotac_nvidia"
176   #else   else
177   #export SPECIALDEVICE="zotac_intel"   export SPECIALDEVICE="zotac_intel"
178   #fi   fi
179   #fi   fi
180    
181   # check for special devices/clients:   # check for special devices/clients:
182   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 318  run_hardware_detection_disks() Line 212  run_hardware_detection_disks()
212   # all disks but exclude ramdisks   # all disks but exclude ramdisks
213   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
214   # remove the boot device from ALL_DISKS if it was an usbstick   # remove the boot device from ALL_DISKS if it was an usbstick
215   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]   if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
216   then   then
217   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
218   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
219   fi   fi
220   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
221  }  }
222    
223  setup_hdd_partitions_auto()  setup_hdd_partitions()
224  {  {
  ROOTHDD="${HDD}1"  
   
225   # sanity check - should not happen   # sanity check - should not happen
226   if is_mounted --device "${ROOTHDD}"   if is_mounted --device "${ROOTHDD}"
227   then   then
228   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
229   umount "${ROOTHDD}"   umount "${ROOTHDD}"
230   fi   fi
231     if [[ -n ${BOOTHDD} ]]
  # run this only if FDISKPARTITIONBELOW256MB is not already 1  
  if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]  
232   then   then
233   if hdd_size_below_256mb ${HDD}   if is_mounted --device "${BOOTHDD}"
234   then   then
235   FDISKPARTIONBELOW256MB=1   echo "partition: device ${BOOTHDD} is already mounted, umount it" >&2
236   else   umount "${BOOTHDD}"
  FDISKPARTIONBELOW256MB=0  
237   fi   fi
238   fi   fi
239    
240   ## delete disk   if [[ ${INSTALL_METHOD} = auto ]]
  dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die  
   
  if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]  
241   then   then
242   ## setup one bootable partition   # run this only if FDISKPARTITIONBELOW256MB is not already 1
243   #1. n= new disk   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
244   #2. p= primary disk   then
245   #3. 1= first partition   if device_minimum_size "${HDD}" 256
246   #4. 2= default sector start // small disk needs more space for grub2 mbr sector   then
247   #5. ''= defaul sector end   FDISKPARTIONBELOW256MB=1
248   #6. a= bootable flag   else
249   #7. 1= boot flag for partition 1   FDISKPARTIONBELOW256MB=0
250   #8. w= write/quit   fi
251   fdisk ${HDD} &> /dev/null << EOF   fi
252    
253     ## delete disk
254     dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
255    
256     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
257     then
258     ## setup one bootable partition
259     #1. n= new disk
260     #2. p= primary disk
261     #3. 1= first partition
262     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
263     #5. ''= defaul sector end
264     #6. a= bootable flag
265     #7. 1= boot flag for partition 1
266     #8. w= write/quit
267     fdisk ${HDD} &> /dev/null << EOF
268  n  n
269  p  p
270  1  1
# Line 372  a Line 274  a
274  1  1
275  w  w
276  EOF  EOF
277   else   else
278   ## setup one bootable partition   ## setup one bootable partition
279   #1. n= new disk   #1. n= new disk
280   #2. p= primary disk   #2. p= primary disk
281   #3. 1= first partition   #3. 1= first partition
282   #4. ''= default sector start   #4. ''= default sector start
283   #5. ''= defaul sector end   #5. ''= defaul sector end
284   #6. a= bootable flag   #6. a= bootable flag
285   #7. 1= boot flag for partition 1   #7. 1= boot flag for partition 1
286   #8. w= write/quit   #8. w= write/quit
287   fdisk ${HDD} &> /dev/null << EOF   fdisk ${HDD} &> /dev/null << EOF
288  n  n
289  p  p
290  1  1
# Line 392  a Line 294  a
294  1  1
295  w  w
296  EOF  EOF
297     fi
298     else
299     cfdisk ${HDD} || dialog_die
300   fi   fi
301  }  }
302    
 setup_hdd_partitions_manual()  
 {  
  ROOTHDD="${HDD}1"  
  SWAPHDD=""  
  BOOTHDD=""  
  cfdisk ${HDD} || dialog_die  
 }  
   
303  setup_hdd_format()  setup_hdd_format()
304  {  {
305   # sanity check - should not happen   install -d /tmp
306   if is_mounted --device "${ROOTHDD}"   :> /tmp/format.log
307    
308     if [[ -n ${SWAPHDD} ]]
309   then   then
310   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2   # sanity check - should not happen
311   umount "${ROOTHDD}"   if is_mounted --device "${SWAPHDD}"
312     then
313     echo "format: device ${SWAPHDD} is already mounted, umount it" >&2
314     umount "${SWAPHDD}"
315     fi
316     mkswap ${SWAPHDD} || die
317   fi   fi
318    
319   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   if [[ -n ${BOOTHDD} ]]
320  }   then
321     # sanity check - should not happen
322     if is_mounted --device "${BOOTHDD}"
323     then
324     echo "format: device ${BOOTHDD} is already mounted, umount it" >&2
325     umount "${BOOTHDD}"
326     fi
327    
328  install_mount_rootfs()   mkfs."${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" &>> /tmp/format.log || dialog_die
329  {   fi
330   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
331   install -d ${INSTALLROOT}/boot || dialog_die   if [[ -n ${ROOTHDD} ]]
332     then
333     # sanity check - should not happen
334     if is_mounted --device "${ROOTHDD}"
335     then
336     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
337     umount "${ROOTHDD}"
338     fi
339    
340     mkfs."${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" &>> /tmp/format.log || dialog_die
341     fi
342  }  }
343    
344  install_system_image()  install_system_image()
345  {  {
346   pushd ${INSTALLROOT} > /dev/null   pushd ${INSTALLROOT} > /dev/null
347   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${IMAGEROOT}/${CDIMAGENAME} -C ${INSTALLROOT}
348   popd > /dev/null   popd > /dev/null
349  }  }
350    
# Line 435  install_system_settings() Line 355  install_system_settings()
355   # write fstab   # write fstab
356   CONFIG="${INSTALLROOT}/etc/fstab"   CONFIG="${INSTALLROOT}/etc/fstab"
357   clearconfig   clearconfig
358   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"   if [[ -n ${BOOTHDD} ]]
359     then
360     addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/\t${FORMAT_FILESYSTEM_BOOTHDD}\tnoatime\t1 1"
361     fi
362     if [[ -n ${ROOTHDD} ]]
363     then
364     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM_ROOTHDD}\tnoatime\t0 0"
365     fi
366     if [[ -n ${SWAPHDD} ]]
367     then
368     addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
369     fi
370   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
371   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
372    
# Line 446  install_system_settings() Line 377  install_system_settings()
377   addconfig 'NETWORKING="dhcp"'   addconfig 'NETWORKING="dhcp"'
378    
379   # intel framebuffer quirk   # intel framebuffer quirk
380   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]   CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
381     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
382   then   then
383   if [ -e /proc/fb ]   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
384   then   then
385   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
386   then   [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
387   fi   fi
388   fi   fi
389  }  }
390    
391  install_umount_rootfs()  
392    ### installer dialogs ###
393    
394    dialog_die()
395  {  {
396   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   ERROR="$1"
397   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   RETVAL="$?"
398     dialog_install_failure
399     exit 1
400  }  }
401    
402  install_do_reboot()  dialog_warning()
403  {  {
404   reboot   local retval
405    
406     yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
407     retval=$?
408     if [[ ${retval} -eq 1 ]]
409     then
410     clear
411     echo $"The process was aborted."
412     exit 1
413     fi
414  }  }
415    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
416    
417  run_install_normal()  ### installer tasks ###
418    
419    task_setup_system_menu()
420  {  {
421   task_hardware_detection   local mode
422     local retval
423    
424   task_setup_hdd_partitions_manual   mode="$(dialog_setup_system_menu)"
425   dialog_setup_hdd_format   retval=$?
426   setup_hdd_format > /dev/null   [[ ${retval} -eq 1 ]] && return 1
427   install_mount_rootfs   if [[ ${retval} -eq 0 ]]
428   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   then
429     case "${mode}" in
430     "1") run_install auto ;;
431     "2") run_install normal ;;
432     "") task_setup_system_menu;;
433     esac
434     fi
435    }
436    
437   dialog_install_settings  task_hardware_detection()
438   sleep 1  {
439   install_system_settings   local message
440   if is_initrd_supported  
441     run_hardware_detection_disks
442    
443     message+=$"Harddrives:\n"
444    
445     if [[ ! -z ${ALL_DISKS} ]]
446   then   then
447   dialog_install_initrd   for i in ${ALL_DISKS}
448   initrd_config   do
449   initrd_install   message+="\Z3${i}\Zn "
450     done
451     message+="\n"
452   fi   fi
453    
454   dialog_install_bootsector   if [[ ! -z ${ALL_CDROMS} ]]
455   bootloader_config   then
456   bootloader_install   message+="\n"
457     message+=$"Optical disk drives:\n"
458     for i in ${ALL_CDROMS}
459     do
460     message+="\Z3${i}\Zn"
461     done
462     message+="\n"
463     fi
464    
465   install_umount_rootfs   # other devices
466   dialog_install_successful   run_hardware_detection
467     case "${SPECIALDEVICE}" in
468     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
469     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
470     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
471     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
472     esac
473     if [[ ${FORMFACTOR} = laptop ]]
474     then
475     message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
476     fi
477    
478     messagebox -y 12 -h $"Detected hardware:" "${message}"
479    }
480    
481    task_setup_hdd_partitions()
482    {
483     local i
484     local retval
485    
486     if [[ -z ${ALL_DISKS} ]]
487     then
488     dialog_no_harddrive_found
489     exit 1
490     else
491     HDD=$(dialog_select_target_harddrive)
492     retval=$?
493     [[ ${retval} -eq 1 ]] && return 1
494     if [[ ${retval} -eq 0 ]]
495     then
496     dialog_setup_hdd_info
497     setup_hdd_partitions
498     fi
499     fi
500  }  }
501    
502  run_install_auto()  task_main()
503  {  {
504     local method=0
505     local retval
506    
507     while [[ ${method} -le 2 ]]
508     do
509     method=$(dialog_main)
510     retval=$?
511     [[ ${retval} -eq 1 ]] && exit 1
512     if [[ ${retval} -eq 0 ]]
513     then
514     case ${method} in
515     "1") task_setup_system_menu ;;
516     "2") task_hardware_detection ;;
517     "3") install_do_reboot ;;
518     "4") /bin/bash --login -i ;;
519     esac
520     fi
521     done
522    }
523    
524    run_install()
525    {
526     local method="$1"
527    
528   task_hardware_detection   task_hardware_detection
529    
530   task_setup_hdd_partitions_auto   case "${method}" in
531     auto)
532     export BOOTHDD=""
533     export SWAPHDD=""
534     export ROOTHDD="${HDD}1"
535     export FORMAT_FILESYSTEM_BOOTHDD=""
536     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
537     export INSTALL_METHOD="${method}"
538     ;;
539     normal)
540     export BOOTHDD="${HDD}1"
541     export SWAPHDD="${HDD}2"
542     export ROOTHDD="${HDD}3"
543     export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
544     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
545     export INSTALL_METHOD="${method}"
546     ;;
547     single)
548     export BOOTHDD=""
549     export SWAPHDD=""
550     export ROOTHDD="${HDD}1"
551     export FORMAT_FILESYSTEM_BOOTHDD=""
552     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
553     export INSTALL_METHOD="${method}"
554     ;;
555     flash)
556     export BOOTHDD="${HDD}1"
557     export SWAPHDD=""
558     export ROOTHDD="${HDD}2"
559     export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
560     export FORMAT_FILESYSTEM_ROOTHDD="f2fs"
561     export INSTALL_METHOD="${method}"
562     ;;
563     *)
564     die "Unknown install method '${method}', aborting."
565     ;;
566     esac
567    
568     task_setup_hdd_partitions
569   dialog_setup_hdd_format   dialog_setup_hdd_format
570   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
571   install_mount_rootfs   mount_rootfs
572   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
573    
574   dialog_install_settings   dialog_install_settings
# Line 529  run_install_auto() Line 585  run_install_auto()
585   bootloader_config   bootloader_config
586   bootloader_install   bootloader_install
587    
588   install_umount_rootfs   umount_rootfs
589   dialog_install_successful   dialog_install_successful
590  }  }
591    

Legend:
Removed from v.2481  
changed lines
  Added in v.2887